function [train, rTrain, rTrainD, test, rTest, rTestD] = LoadFromFile(filename)
fid = fopen(filename);

d = 1217;
n = 3837;

x = zeros(n, d); % features (sparse)
y = zeros(n, 1); % labels

count = 1;
tline = fgetl(fid);
while ischar(tline)
    sLength = length(tline)-1;
    C = textscan(tline(2:sLength), ' %d:%f');
    
    for k = 1:length(C{1})
        x(count, 1+C{1}(k)) = C{2}(k);
    end
    y(count) = 1+tline(1) - '0';
    count = count + 1;
    if count > n
        break;
    end
    
    tline = fgetl(fid);
end

nClass = length(unique(y));

yD = zeros(n, nClass);
for i = 1:n
    yD(i, y(i)) = 1;
end

samp = randsample(n, floor(n/2));
train = x(samp, :);
rTrain = y(samp, :);
rTrainD = yD(samp, :);
test = x(setdiff(1:n, samp), :);
rTest = y(setdiff(1:n, samp), :);
rTestD = yD(setdiff(1:n, samp), :);

fclose(fid);
